/**
* Wszystkie prawa zastrzeone.
* Autor: Tomasz Kaczanowski
* Licencja: Kod mona modyfikowa, oraz uy we wasnych rozwizaniach nieodpatnie,
* jedyny wymg - konieczno podania w dokumentacji informacji o wykorzystaniu kodu
* oraz autora - Tomasza Kaczanowskiego. Jeli jest jaka informacja o programie
* - rwnie tam naley umieci adekwatn informacj.
*/

#include "mydefaultobj.h"
#include <stdio.h>


struct myTextObj
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    char *buftext;
};

struct myIntegerObj
{
    ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    int ivalue;
};

void myTextObjDestructor(struct TDefaultObj *aval)
{
    struct myTextObj *lptr = (struct myTextObj *)aval;
    if (lptr)
    {
        if (lptr->buftext)
        {
            free(lptr->buftext);
        }
        free(lptr);
    }

}

struct TDefaultObj *myTextObjClone(struct TDefaultObj *aval)
{
    struct myTextObj *lptr = (struct myTextObj *)aval;
    struct myTextObj *lres = NULL;
    if (lptr)
    {
        lres = (struct myTextObj *)malloc(sizeof(struct myTextObj));
        if (lres)
        {
        	memcpy(lres, lptr, sizeof(struct myTextObj));
            if (lptr->buftext)
            {
                lres->buftext = (char *)malloc(strlen(lptr->buftext) + 1);
                if (lres->buftext)
                	strcpy(lres->buftext, lptr->buftext);
        	}
        }
	}
    return (struct TDefaultObj *)lres;
}

struct myTextObj *CreateTextObj(const char* astr)
{
    struct myTextObj *lres = (struct myTextObj *)malloc(sizeof(struct myTextObj));
    if (lres)
    {
        lres->buftext = (char *)malloc(strlen(astr) + 1);
        if (lres->buftext)
        	strcpy(lres->buftext, astr);
        lres->fooDestructor = myTextObjDestructor;
        lres->fooGetSize = NULL;
        lres->fooCloneObj = myTextObjClone;
    }
    return lres;
}

size_t myIntegerObjGetSize(struct TDefaultObj *aval)
{
    return  sizeof(struct myIntegerObj);
}

struct myIntegerObj *CreateIntegerObj(int aval)
{
	struct myIntegerObj *lres = (struct myIntegerObj *)malloc(sizeof(struct myIntegerObj));
    if (lres)
    {
        lres->ivalue = aval;
        lres->fooDestructor = NULL;
        lres->fooGetSize = myIntegerObjGetSize;
        lres->fooCloneObj = NULL;
    }
    return lres;
}


int main()
{
    struct myTextObj *txta, *txtb;
    struct myIntegerObj *iobja, *iobjb;
    txta = CreateTextObj("Mj Text 1");
    iobja = CreateIntegerObj(7);
    txtb = (struct myTextObj *)CloneDefaultObject((struct TDefaultObj *)txta);
    iobjb = (struct myIntegerObj *)CloneDefaultObject((struct TDefaultObj *)iobja);

    FreeDefaultObject((struct TDefaultObj *)txtb);
    FreeDefaultObject((struct TDefaultObj *)iobjb);
    FreeDefaultObject((struct TDefaultObj *)iobja);
    FreeDefaultObject((struct TDefaultObj *)txta);

    return 0;
}

